Index: java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 105)
@@ -1,4 +1,5 @@
 package com.framsticks.hosting;
 
+import static com.framsticks.structure.TreeOperations.*;
 import static com.framsticks.util.lang.Strings.assureNotEmpty;
 
@@ -10,17 +11,17 @@
 import com.framsticks.communication.queries.RegisterRequest;
 import com.framsticks.communication.queries.SetRequest;
-import com.framsticks.core.LocalTree;
-import com.framsticks.core.Tree;
-import com.framsticks.core.Path;
 import com.framsticks.params.*;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.parsers.Savers;
+import com.framsticks.structure.LocalTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableParent;
@@ -29,6 +30,6 @@
 import com.framsticks.util.lang.Strings;
 
-import static com.framsticks.core.TreeOperations.*;
 import static com.framsticks.params.AccessOperations.*;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 import java.net.Socket;
@@ -37,5 +38,5 @@
  * @author Piotr Sniegowski
  */
-public class ClientAtServer extends AbstractJoinable implements RequestHandler, JoinableParent, ExceptionResultHandler {
+public class ClientAtServer extends AbstractJoinable implements RequestHandler, JoinableParent, ExceptionHandler {
 
 	protected final Server server;
@@ -126,5 +127,5 @@
 	protected void handleInTree(final Tree tree, final ApplicationRequest request, final ServerSideResponseFuture responseCallback, final String usedPrefix) {
 
-		tryGet(tree, request.getActualPath(), new FutureHandler<Path>(responseCallback) {
+		tryGet(tree, request.getActualPath(), new Future<Path>(responseCallback) {
 			@Override
 			protected void result(final Path path) {
@@ -142,5 +143,5 @@
 						throw new FramsticksException().msg("mismatch objects during fetch").arg("path", path);
 					}
-					responseCallback.pass(new Response(true, "", File.single(printToFile(path.getTextual(), access))));
+					responseCallback.pass(new Response(true, "", printToFile(path.getTextual(), access)));
 
 					return;
@@ -149,9 +150,8 @@
 				if (request instanceof SetRequest) {
 					SetRequest setRequest = (SetRequest) request;
-					tree.set(path, access.getFramsClass().getParamEntry(setRequest.getField(), PrimitiveParam.class), setRequest.getValue(), new FutureHandler<Integer>(responseCallback) {
+					tree.set(path, getParam(access, setRequest.getField(), PrimitiveParam.class), setRequest.getValue(), new Future<Integer>(responseCallback) {
 						@Override
 						protected void result(Integer flag) {
-							responseCallback.pass(new Response(true, FlagsUtil.write(SetStateFlags.class, flag, null), null));
-
+							responseCallback.pass(new Response(true, FlagsUtil.write(SetStateFlags.class, flag, null)));
 						}
 					});
@@ -161,17 +161,15 @@
 				if (request instanceof CallRequest) {
 					final CallRequest callRequest = (CallRequest) request;
-					tree.call(path, access.getFramsClass().getParamEntry(callRequest.getProcedure(), ProcedureParam.class), callRequest.getArguments().toArray(), Object.class, new FutureHandler<Object>(responseCallback) {
+					tree.call(path, getParam(access, callRequest.getProcedure(), ProcedureParam.class), callRequest.getArguments().toArray(), Object.class, new Future<Object>(responseCallback) {
 						@Override
-						protected void result(Object result) {
-							ListSink sink = new ListSink();
-							sink.print("Result:").breakLine();
-							sink.print("value:");
-							sink.print("[");
-							if (result != null) {
-								sink.print(result);
+						protected void result(final Object result) {
+							if (result == null) {
+								responseCallback.pass(new Response(true, ""));
+								return;
 							}
-							sink.print("]");
-
-							responseCallback.pass(new Response(true, "", File.single(new File("", new ListSource(sink.getOut())))));
+							final Object wrapped = AccessOperations.wrapValueInResultIfPrimitive(result);
+							final File file = AccessOperations.convert(File.class, wrapped, tree.getRegistry());
+							responseCallback.pass(new Response(true, "", file));
+
 						}
 					});
@@ -184,5 +182,5 @@
 						throw new FramsticksException().msg("info should be available");
 					}
-					responseCallback.pass(new Response(true, null, File.single(new File(path.getTextual(), new ListSource(Savers.saveFramsClass(new ListSink(), framsClass).getOut())))));
+					responseCallback.pass(new Response(true, null, new File(path.getTextual(), new ListSource(Savers.saveFramsClass(new ListSink(), framsClass).getOut()))));
 					return;
 				}
@@ -191,5 +189,5 @@
 					RegisterRequest register = (RegisterRequest) request;
 
-					cliObject.addListener(path, access.getFramsClass().getParamEntry(register.getEventName(), EventParam.class), usedPrefix, responseCallback);
+					cliObject.addListener(path, getParam(access, register.getEventName(), EventParam.class), usedPrefix, responseCallback);
 					return;
 				}
Index: java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 105)
@@ -5,9 +5,9 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.Tree;
 import com.framsticks.params.ParamFlags;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.structure.Tree;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
Index: java/main/src/main/java/com/framsticks/model/Part.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Part.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/model/Part.java	(revision 105)
@@ -12,10 +12,15 @@
 public class Part extends BasePart implements ModelComponent {
 
-	@ParamAnnotation
-	public double rx, ry, rz;
+	@ParamAnnotation(id = "rx")
+	public double rotationX;
 
+	@ParamAnnotation(id = "ry")
+	public double rotationY;
 
-	public Point3d getRotation() { return new Point3d(rx, ry, rz); }
-	public void setRotation(Point3d r) { rx = r.x; ry = r.y; rz = r.z; }
+	@ParamAnnotation(id = "rz")
+	public double rotationZ;
+
+	public Point3d getRotation() { return new Point3d(rotationX, rotationY, rotationZ); }
+	public void setRotation(Point3d r) { rotationX = r.x; rotationY = r.y; rotationZ = r.z; }
 
 	@ParamAnnotation(id = "dn")
Index: java/main/src/main/java/com/framsticks/params/Access.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Access.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/Access.java	(revision 105)
@@ -14,17 +14,11 @@
  *         surname with my personal data)
  */
-public interface Access {
+public interface Access extends ParamCollection {
 
-	Param getParam(int i);
+	String getTypeId();
 
-	Param getParam(String id);
+	Object call(String id, Object... arguments);
 
-	String getId();
-
-	int getParamCount();
-
-	Object call(String id, Object[] arguments);
-
-	Object call(ProcedureParam param, Object[] arguments);
+	Object call(ProcedureParam param, Object... arguments);
 
 	<T> T get(int i, Class<T> type);
@@ -57,6 +51,4 @@
 	Object createAccessee();
 
-	Iterable<Param> getParams();
-
 	FramsClass getFramsClass();
 
Index: java/main/src/main/java/com/framsticks/params/AccessOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 105)
@@ -6,4 +6,5 @@
 import javax.annotation.Nullable;
 
+import org.apache.commons.lang3.ClassUtils;
 import org.apache.logging.log4j.Logger;
 import org.apache.logging.log4j.LogManager;
@@ -12,4 +13,5 @@
 import com.framsticks.params.types.ListParam;
 import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.structure.messages.Result;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.FramsticksUnsupportedOperationException;
@@ -114,5 +116,5 @@
 					first.set(false);
 					if (rootAccess != null) {
-						if (name.equals(rootAccess.getId())) {
+						if (name.equals(rootAccess.getTypeId())) {
 							needAdd.set(false);
 							currentAccess.set(rootAccess);
@@ -224,9 +226,7 @@
 		if (access instanceof ObjectAccess) {
 			ObjectAccess objectAccess = (ObjectAccess) access;
-			FramsClass framsClass = access.getFramsClass();
-			assert framsClass != null;
 			boolean headerNeeded = true;
 			// sink.print(framsClass.getId()).print(":").breakLine();
-			for (PrimitiveParam<?> p : filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
+			for (PrimitiveParam<?> p : filterInstanceof(access.getParams(), PrimitiveParam.class)) {
 
 				Object value = objectAccess.get(p, Object.class);
@@ -236,10 +236,12 @@
 
 				if (headerNeeded) {
-					sink.print(framsClass.getId()).print(":").breakLine();
+					sink.print(access.getTypeId()).print(":").breakLine();
 					headerNeeded = false;
 				}
 
-				sink.print(p.getId()).print(":");
-				p.save(sink, value);
+				String stringValue = p.serialize(value);
+
+				sink.print(p.getId()).print(":").print(stringValue);
+				// p.save(sink, stringValue);
 				sink.breakLine();
 			}
@@ -414,4 +416,14 @@
 	}
 
+	public static Object wrapValueInResultIfPrimitive(Object object) {
+		Class<?> javaClass = object.getClass();
+		if (ClassUtils.isPrimitiveOrWrapper(javaClass)) {
+			return new Result(object);
+		}
+		if (javaClass.equals(String.class)) {
+			return new Result(object);
+		}
+		return object;
+	}
 
 	/**
Index: java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 105)
@@ -48,6 +48,6 @@
 
 	@Override
-	public String getId() {
-		return "l " + elementAccess.getId();
+	public String getTypeId() {
+		return "l " + elementAccess.getTypeId();
 	}
 
Index: java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 105)
@@ -3,5 +3,4 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Containers;
 import com.framsticks.util.lang.Strings;
@@ -10,5 +9,4 @@
 import java.util.*;
 
-import javax.annotation.Nonnull;
 import javax.annotation.concurrent.Immutable;
 
@@ -30,5 +28,5 @@
 @Immutable
 @FramsClassAnnotation(id = "class", name = "class")
-public class FramsClass {
+public class FramsClass implements ParamCollection {
 
 	private final static Logger log = LogManager.getLogger(FramsClass.class);
@@ -55,5 +53,5 @@
 
 	@ParamAnnotation(id = "props", name = "props")
-	public List<Param> getParamEntries() {
+	public List<Param> getParams() {
 		return Collections.unmodifiableList(paramList);
 	}
@@ -135,38 +133,4 @@
 	}
 
-	public @Nonnull <T extends Param> T castedParam(@Nonnull final Param param, @Nonnull final Class<T> type, Object name) {
-		if (param == null) {
-			// return null;
-			throw new FramsticksException().msg("param is missing").arg("name", name).arg("in", this);
-		}
-		if (!type.isInstance(param)) {
-			// return null;
-			throw new FramsticksException().msg("wrong type of param").arg("actual", param.getClass()).arg("requested", type).arg("in", this);
-		}
-		return type.cast(param);
-	}
-
-	/**
-	 * Gets the param entry.
-	 *
-	 * @param i
-	 *            the offset of parameter
-	 * @return the param entry
-	 */
-	public @Nonnull <T extends Param> T getParamEntry(final int i, @Nonnull final Class<T> type) {
-		return castedParam(getParam(i), type, i);
-	}
-
-	/**
-	 * Gets the param entry.
-	 *
-	 * @param id
-	 *            the getId of parameter
-	 * @return the param entry
-	 */
-	public @Nonnull <T extends Param> T getParamEntry(@Nonnull final String id, @Nonnull final Class<T> type) {
-		return castedParam(getParam(id), type, id);
-	}
-
 	public Param getParam(int i) {
 		if (i < 0 || i >= paramList.size()) {
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 105)
@@ -19,5 +19,5 @@
 	public ListAccess(Access elementAccess) {
 		this.elementAccess = elementAccess;
-		this.containedTypeName = elementAccess.getId();
+		this.containedTypeName = elementAccess.getTypeId();
 		paramBuilder = elementAccess.buildParam(new ParamBuilder());
 	}
@@ -51,10 +51,10 @@
 
 	@Override
-	public Object call(String id, Object[] arguments) {
+	public Object call(String id, Object... arguments) {
 		throw new InvalidOperationException().msg("list access does not support calling methods").arg("id", id).arg("access", this);
 	}
 
 	@Override
-	public Object call(ProcedureParam param, Object[] arguments) {
+	public Object call(ProcedureParam param, Object... arguments) {
 		throw new InvalidOperationException().msg("list access does not support calling methods").arg("param", param).arg("access", this);
 	}
Index: java/main/src/main/java/com/framsticks/params/MessageLogger.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/MessageLogger.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/MessageLogger.java	(revision 105)
@@ -1,5 +1,5 @@
 package com.framsticks.params;
 
-import com.framsticks.core.Message;
+import com.framsticks.structure.messages.Message;
 
 public class MessageLogger extends EventListeners<Message> {
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 105)
@@ -85,10 +85,4 @@
 	}
 
-	public boolean isNumeric() {
-		return false;
-	}
-
-	public abstract Class<?> getStorageType();
-
 	public boolean hasFlag(int flag) {
 		return (flags & flag) != 0;
Index: java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 105)
@@ -79,4 +79,6 @@
 	protected final OneTime<Method> adder = new OneTime<>("adder");
 	protected final OneTime<Method> remover = new OneTime<>("remover");
+	protected final OneTime<Class<? extends Param>> paramType = new OneTime<>("paramType");
+
 	protected int flags = 0;
 
@@ -262,8 +264,19 @@
 	}
 
+	// public static <T extends Param> boolean isParamAnnorationOfTypeOrUnspecified(ParamAnnotation paramAnnotation, Class<T> paramType) {
+	// 	return paramAnnotation.paramType().equals(Param.class) || paramAnnotation.paramType().equals(paramType);
+	// }
+
+	// public static <T extends Param> boolean isParamAnnorationOfType(ParamAnnotation paramAnnotation, Class<T> paramType) {
+	// 	return paramAnnotation.paramType().equals(paramType);
+	// }
+
 	void add(ParamAnnotation paramAnnotation, Member member, String name) {
 		this.name.set(name);
 		annotations.add(paramAnnotation);
 		flags |= paramAnnotation.flags();
+		if (!paramAnnotation.paramType().equals(Param.class)) {
+			paramType.set(paramAnnotation.paramType());
+		}
 		if (member instanceof Field) {
 			field.set((Field) member);
@@ -273,10 +286,7 @@
 		if (member instanceof Method) {
 			Method m = (Method) member;
-			if (!paramAnnotation.paramType().equals(Param.class)) {
-				if (paramAnnotation.paramType().equals(ProcedureParam.class)) {
-					caller.set(m);
-					return;
-				}
-				throw new ConstructionException().msg("explicit set of paramType different than ProcedureParam is not yet supported").arg("name", name).arg("method", m).arg("in", this);
+			if (paramAnnotation.paramType().equals(ProcedureParam.class)) {
+				caller.set(m);
+				return;
 			}
 			Type[] ps = m.getGenericParameterTypes();
@@ -392,5 +402,5 @@
 	protected static final Map<Class<?>, Set> setsCache = Collections.synchronizedMap(new IdentityHashMap<Class<?>, Set>());
 
-	public static Set getAllCandidates(Class<?> javaClass) throws ConstructionException {
+	public static Set getAllCandidates(final Class<?> javaClass) throws ConstructionException {
 		Set result = setsCache.get(javaClass);
 		if (result != null) {
@@ -399,7 +409,8 @@
 
 		List<Class<?>> javaClasses = new LinkedList<>();
-		while (javaClass != null) {
-			javaClasses.add(0, javaClass);
-			javaClass = javaClass.getSuperclass();
+		Class<?> jc = javaClass;
+		while (jc != null) {
+			javaClasses.add(0, jc);
+			jc = jc.getSuperclass();
 		}
 
@@ -473,4 +484,5 @@
 		// 	throw new ConstructionException().msg("void is not a valid type");
 		// }
+
 
 		if (type instanceof ParameterizedType) {
@@ -562,8 +574,10 @@
 	}
 
-
 	public ParamBuilder induceParamType(ParamBuilder builder) {
 		Method method = getCaller();
 		if (method == null) {
+			if (paramType.has()) {
+				return builder.type(paramType.get());
+			}
 			return induceParamType(builder, getType());
 		}
Index: java/main/src/main/java/com/framsticks/params/ParamCollection.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamCollection.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/params/ParamCollection.java	(revision 105)
@@ -0,0 +1,14 @@
+package com.framsticks.params;
+
+public interface ParamCollection {
+
+	public Param getParam(int i);
+
+	public Param getParam(String id);
+
+	public int getParamCount();
+
+	public Iterable<Param> getParams();
+
+
+}
Index: java/main/src/main/java/com/framsticks/params/ParamsUtil.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamsUtil.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ParamsUtil.java	(revision 105)
@@ -3,4 +3,7 @@
 import java.util.ArrayList;
 import java.util.List;
+import java.util.Map;
+
+import javax.annotation.Nonnull;
 
 import com.framsticks.util.FramsticksException;
@@ -29,5 +32,5 @@
 			Object object = a.getSelected();
 			if (!type.isInstance(object)) {
-				throw new FramsticksException().msg("extracted object is of invalid type").arg("object", object).arg("desired", type).arg("actual", object.getClass()).arg("framsclass", a.getFramsClass());
+				throw new FramsticksException().msg("extracted object is of invalid type").arg("object", object).arg("desired", type).arg("actual", object.getClass()).arg("access", a);
 			}
 			result.add(type.cast(object));
@@ -88,3 +91,149 @@
 	}
 
+	public static Object[] arguments(Object... args) {
+		return args;
+	}
+
+	public static Param getParam(ParamCollection collection, int i) {
+		return collection.getParam(i);
+	}
+
+	public static Param getParam(ParamCollection collection, String id) {
+		return collection.getParam(id);
+	}
+
+	public static @Nonnull <T extends Param> T castedParam(ParamCollection collection, @Nonnull final Param param, @Nonnull final Class<T> type, Object name) {
+		if (param == null) {
+			// return null;
+			throw new FramsticksException().msg("param is missing").arg("name", name).arg("in", collection);
+		}
+		if (!type.isInstance(param)) {
+			// return null;
+			throw new FramsticksException().msg("wrong type of param").arg("actual", param.getClass()).arg("requested", type).arg("in", collection);
+		}
+		return type.cast(param);
+	}
+
+	/**
+	 * Gets the param entry.
+	 *
+	 * @param i
+	 *            the offset of parameter
+	 * @return the param entry
+	 */
+	public static @Nonnull <T extends Param> T getParam(ParamCollection collection, final int i, @Nonnull final Class<T> type) {
+		return castedParam(collection, collection.getParam(i), type, i);
+	}
+
+	/**
+	 * Gets the param entry.
+	 *
+	 * @param id
+	 *            the getId of parameter
+	 * @return the param entry
+	 */
+	public static @Nonnull <T extends Param> T getParam(ParamCollection collection, @Nonnull final String id, @Nonnull final Class<T> type) {
+		return castedParam(collection, collection.getParam(id), type, id);
+	}
+
+	public static final String SERIALIZED = "@Serialized:";
+
+	public static class SerializationContext {
+		protected final StringBuilder builder = new StringBuilder();
+		protected final ArrayList<Object> objects = new ArrayList<>();
+
+		protected void appendString(String value) {
+			builder.append('"').append(value).append('"');
+		}
+
+		protected boolean serializeInternal(Object value) {
+			if (value == null) {
+				builder.append("null");
+				return true;
+			}
+			/** indexOf is not used here, because it uses equals() internally, which results in StackOverflowError */
+			Class<?> type = value.getClass();
+			if (type.equals(String.class)) {
+				String stringValue = (String) value;
+				appendString(stringValue);
+				return stringValue.startsWith(SERIALIZED);
+			}
+			if (type.equals(Boolean.class)) {
+				builder.append(((Boolean) value) ? "1" : "0");
+				return false;
+			}
+			if (type.equals(Double.class) || type.equals(Integer.class)) {
+				builder.append(value.toString());
+				return false;
+			}
+
+			for (int i = 0; i < objects.size(); ++i) {
+				if (objects.get(i) == value) {
+					builder.append("^").append(i);
+					return true;
+				}
+			}
+
+			if (List.class.isAssignableFrom(type)) {
+				objects.add(value);
+				List<?> list = (List<?>) value;
+				boolean placeComma = false;
+				builder.append("[");
+				for (Object element : list) {
+					if (placeComma) {
+						builder.append(",");
+					} else {
+						placeComma = true;
+					}
+					serializeInternal(element);
+				}
+				builder.append("]");
+				return true;
+			}
+			if (Map.class.isAssignableFrom(type)) {
+				objects.add(value);
+				Map<?, ?> map = (Map<?, ?>) value;
+				boolean placeComma = false;
+				builder.append("{");
+				for (Map.Entry<?, ?> entry : map.entrySet()) {
+					if (placeComma) {
+						builder.append(",");
+					} else {
+						placeComma = true;
+					}
+					if (!(entry.getKey() instanceof String)) {
+						throw new FramsticksException().msg("non string keys are not allowed in serialization").arg("key type", entry.getKey().getClass());
+					}
+					appendString((String) entry.getKey());
+					builder.append(":");
+					serializeInternal(entry.getValue());
+				}
+				builder.append("}");
+				return true;
+			}
+			throw new FramsticksException().msg("invalid type for serialization").arg("type", type);
+		}
+
+		public String serialize(Object value) {
+			if (value instanceof String) {
+				String stringValue = (String) value;
+				if (!stringValue.startsWith(SERIALIZED)) {
+					return stringValue;
+				}
+			}
+			boolean complex = serializeInternal(value);
+			return (complex ? SERIALIZED : "") + builder.toString();
+		}
+
+	}
+
+
+	public static <T> String serialize(T value) {
+		return new SerializationContext().serialize(value);
+	}
+
+	public static <T> T deserialize(String value, Class<T> type) {
+		return null;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/PrimitiveParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 105)
@@ -3,5 +3,7 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
+import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Numbers;
+import com.framsticks.util.lang.Strings;
 
 import javax.annotation.concurrent.Immutable;
@@ -33,7 +35,7 @@
 	}
 
-	public void save(Sink sink, Object value) {
-		sink.print(value);
-	}
+	// public void save(Sink sink, Object value) {
+	// 	sink.print(value);
+	// }
 
 	protected <T> T tryCastAndReturn(Object value, Class<T> type) {
@@ -97,3 +99,16 @@
 	}
 
+	@Override
+	public <T> String serialize(T value) {
+		return Strings.toStringNullProof(value);
+	}
+
+	@Override
+	public <T> T deserialize(String text, T currentValue, Class<T> type) {
+		try {
+			return Casting.nullOrThrowCast(type, reassign(text, currentValue).getValue());
+		} catch (CastFailure e) {
+			return null;
+		}
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 105)
@@ -1,10 +1,6 @@
 package com.framsticks.params;
-
-import java.util.HashMap;
-import java.util.Map;
 
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
-
 
 /**
@@ -18,13 +14,9 @@
 public class PropertiesAccess extends SimpleAbstractAccess {
 
-	public Map<String, Object> properties;
+	protected PropertiesObject properties;
 
 	@Override
-	public Map<String, Object> createAccessee() {
-		return PropertiesAccess.createPropertiesMap();
-	}
-
-	public static Map<String, Object> createPropertiesMap() {
-		return new HashMap<String, Object>();
+	public PropertiesObject createAccessee() {
+		return new PropertiesObject(framsClass.getId());
 	}
 
@@ -43,23 +35,18 @@
 		assert properties != null;
 		assert param != null;
-		Object object = properties.get(param.getId());
-		if (object != null) {
-			try {
-				return type.cast(object);
-			} catch (ClassCastException e) {
-				throw (ClassCastException) new ClassCastException("property " + param + " type is " + object.getClass().getName() + ", not " + type.getName()).initCause(e);
-			}
+		Object object = properties.get(param.getId(), Object.class);
+		if (object == null) {
+			return null;
 		}
 		try {
-			return param.getDef(type);
+			return type.cast(object);
 		} catch (ClassCastException e) {
-			throw (ClassCastException) new ClassCastException("default value of property " + param + " is not of type " + type.getName()).initCause(e);
+			throw (ClassCastException) new ClassCastException("property " + param + " type is " + object.getClass().getName() + ", not " + type.getName()).initCause(e);
 		}
-
 	}
 
 	@Override
 	protected <T> void internalSet(ValueParam param, T value) {
-		properties.put(param.getId(), value);
+		properties.set(param.getId(), value);
 	}
 
@@ -73,8 +60,7 @@
 	 *            the properties with parameters values
 	 */
-	@SuppressWarnings("unchecked")
 	@Override
 	public PropertiesAccess select(Object object) {
-		properties = ParamsUtil.selectObjectForAccess(this, object, Map.class);
+		properties = ParamsUtil.selectObjectForAccess(this, object, PropertiesObject.class);
 		return this;
 	}
@@ -82,5 +68,5 @@
 	/** covariant */
 	@Override
-	public Map<String, Object> getSelected() {
+	public PropertiesObject getSelected() {
 		return properties;
 	}
@@ -97,10 +83,10 @@
 
 	@Override
-	public Object call(String id, Object[] arguments) {
+	public Object call(String id, Object... arguments) {
 		throw new InvalidOperationException().msg("properties access does not support calling methods").arg("id", id);
 	}
 
 	@Override
-	public Object call(ProcedureParam param, Object[] arguments) {
+	public Object call(ProcedureParam param, Object... arguments) {
 		throw new InvalidOperationException().msg("properties access does not support calling methods").arg("param", param);
 	}
Index: java/main/src/main/java/com/framsticks/params/PropertiesObject.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesObject.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/params/PropertiesObject.java	(revision 105)
@@ -0,0 +1,47 @@
+package com.framsticks.params;
+
+import java.util.Map;
+import java.util.TreeMap;
+
+import com.framsticks.util.lang.Casting;
+
+public class PropertiesObject {
+
+	protected final String framsTypeName;
+	protected final Map<String, Object> values = new TreeMap<>();
+
+	/**
+	 * @param framsTypeName
+	 */
+	public PropertiesObject(String framsTypeName) {
+		this.framsTypeName = framsTypeName;
+	}
+
+	public <T> void set(String id, T value) {
+		values.put(id, value);
+	}
+
+	public <T> T get(String id, Class<T> type) {
+		return Casting.nullOrThrowCast(type, values.get(id));
+	}
+
+	public void clear() {
+		values.clear();
+	}
+
+	public int size() {
+		return values.size();
+	}
+
+	@Override
+	public String toString() {
+		return values.toString();
+	}
+
+	/**
+	 * @return the framsTypeName
+	 */
+	public String getFramsTypeName() {
+		return framsTypeName;
+	}
+}
Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 105)
@@ -131,5 +131,5 @@
 
 	@Override
-	public Object call(String id, Object[] arguments) {
+	public Object call(String id, Object... arguments) {
 		try {
 			try {
@@ -151,5 +151,5 @@
 
 	@Override
-	public Object call(ProcedureParam param, Object[] arguments) {
+	public Object call(ProcedureParam param, Object... arguments) {
 		return call(param.getId(), arguments);
 	}
@@ -162,5 +162,5 @@
 
 		try {
-			for (ValueParam p : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
+			for (ValueParam p : filterInstanceof(framsClass.getParams(), ValueParam.class)) {
 				setValue(p, p.getDef(Object.class));
 			}
